package jesse.keeblarcraft.gui.ShopKeeperGUI;

import jesse.keeblarcraft.GuiMgr.ShopKeeper.ShopKeeperInventory;
import jesse.keeblarcraft.GuiMgr.ShopKeeper.StoreItem;
import jesse.keeblarcraft.gui.Generics.ClickableLayer;
import net.minecraft.client.gui.screen.narration.NarrationMessageBuilder;
import net.minecraft.text.Text;
import net.minecraft.util.Identifier;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

// This is the main section in the GUI that will display the stores "merchandise" -- all the items on sale.
public class MerchandiseScroller {
    private final ShopKeeperInventory storeInventory;

    // Key = item name
    // Value = the drawable slot for it
    // The KVP keeps it so duplicate items don't take up more than 1 store slot
    private final HashMap<String, DrawableStoreItem> drawableInventory;

    public MerchandiseScroller(ShopKeeperInventory storeInventory) {
        this.storeInventory = storeInventory;
        drawableInventory = new HashMap<>();
    }

    public Integer Size() {
        return storeInventory.Size();
    }

    public void Add(StoreItem item) {
        storeInventory.Add(item);
        drawableInventory.put(item.GetUPC(), new DrawableStoreItem(item.GetName(), item.GetCost()));
    }

    public void Remove(String upc) {
        storeInventory.Remove(upc);
    }
}
