package jesse.keeblarcraft.gui.ShopKeeperGUI;

import jesse.keeblarcraft.gui.Generics.ClickableLayer;
import net.minecraft.client.gui.screen.narration.NarrationMessageBuilder;

import net.minecraft.text.Text;
import net.minecraft.util.Identifier;

public class Scrollbar extends ClickableLayer {
    private boolean isDragging = false;
    private int scrollbarStart = 0;
    private int scrollbarEnd = 0;

    public Scrollbar(Identifier texture, Text layerName, int width, int height, int startX, int startY, int scrollbarStart, int scrollbarMaxLength) {
        super(texture, layerName, width, height, startX, startY);
        this.scrollbarStart = scrollbarStart;
        this.scrollbarEnd = startY + scrollbarMaxLength;
    }

    @Override
    protected void onDrag(double mX, double mY, double dX, double dY) {
        // We only want to enable dragging if this feature is being toggled
        if (dY > 0) {
           dY = 1.0;
        } else {
            dY = -1.0;
        }

        if (isDragging && mY >= this.scrollbarStart && mY <= this.scrollbarEnd) {
            this.MoveLayer(this.getX(), (int)mY - (this.getHeight() / 2));
        }
    }

    @Override
    public boolean mouseScrolled(double mouseX, double mouseY, double horizontalAmount, double verticalAmount) {
        // We intentionally switch the scroll direction since it is backwards
        // The number set to is the speed of scrolling
        if (verticalAmount > 0) {
            verticalAmount = -3;
        } else {
            verticalAmount = 3;
        }


        int newY = this.getY() + (int) verticalAmount;
        System.out.println("Mouse move. newY: " + newY + " -> this.getY()=" + this.getY());
        if (newY >= this.scrollbarStart-12 && newY <= this.scrollbarEnd-9) {
            this.MoveLayer(this.getX(), newY);
        }

        return true;
    }

    @Override
    public boolean mouseClicked(double mouseX, double mouseY, int button) {
        SetDragging(true);
        return true;
    }

    @Override
    public boolean mouseReleased(double mouseX, double mouseY, int button) {
        SetDragging(false);
        return true;
    }

    public Boolean IsDragging() {
        return this.isDragging;
    }

    public void SetDragging(boolean b) {
        System.out.println("Toggling dragging mode on scrollbar");
        this.isDragging = b;
    }

    @Override
    protected void appendClickableNarrations(NarrationMessageBuilder builder) {}
}
